package combo;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.io.IOException;
import java.util.Properties;

public class Connect {

    private static Connection cn = null;

    public static void openConnection() {
        if (cn == null) {
            try {
                Properties propertie = new Properties();
                propertie.load(Connect.class.getResourceAsStream("/database.properties"));
                String host = propertie.getProperty("mysqlHost");
                String user = propertie.getProperty("mysqlUser");
                String password = propertie.getProperty("mysqlPasw");
                String url = "jdbc:mysql://" + host + "/mysql";
                Class.forName("org.gjt.mm.mysql.Driver");
                cn = DriverManager.getConnection(url, user, password);

            } catch (IOException e) {
                System.out.println("File database.properties not found!");
            } catch (ClassNotFoundException e) {
                System.out.println("Driver not found!");
            } catch (SQLException e) {
                System.out.println("no connect");
            }
        }
    }

    public static void closeConnection() {
        if (cn != null) {
            try {
                cn.close();
                cn = null;
            } catch (SQLException e) {
                e.printStackTrace();
            }
        }
    }

    public static Connection getConnection() {
        if (cn == null)
            openConnection();
        return cn;
    }

}
