package combo;

import java.sql.*;
import java.io.*;
import java.util.Random;
import java.util.Properties;
import java.util.HashMap;

public class DataBase {
    public static void createTreeDbIfNotExists() {
        try {
            Connection con = Connect.getConnection();
            Properties propertie = new Properties();
            propertie.load(DataBase.class.getResourceAsStream("/database.properties"));
            String database = propertie.getProperty("mysqlDb");
            con.setAutoCommit(false);
            Statement stmt = con.createStatement();
            String sql = "CREATE DATABASE IF NOT EXISTS " + database;
            stmt.execute(sql);
            con.commit();
            sql = "USE " + database;
            stmt.execute(sql);
            con.commit();
            sql = "CREATE TABLE IF NOT EXISTS " +
                    "RandomWords(item_id INT UNSIGNED not null AUTO_INCREMENT,item_nm VARCHAR (200),item_cd VARCHAR (15),PRIMARY KEY ( item_id ))";
            stmt.execute(sql);
            con.commit();
            sql = "Select * from RandomWords";
            ResultSet rs = stmt.executeQuery(sql);
            if (!rs.next()) {
                populateDBRendom(con, database);
            }
        }
        catch (SQLException e) {
            System.out.println(e.getMessage());
        } catch (IOException e) {
            e.printStackTrace();
        }
        finally {
            Connect.closeConnection();
        }
    }

    private static void populateDBRendom(Connection con, String database) {        
        try {
            Statement stmt = con.createStatement();
            String sql = "USE " + database;
            stmt.execute(sql);
            con.commit();
            PreparedStatement pstmt;
            InputStream is = DataBase.class.getResourceAsStream("/100000words.txt");
            ByteArrayOutputStream baos = new ByteArrayOutputStream();
            int b;
            while ((b = is.read()) != -1) {
                baos.write(b);
            }
            String strWords = baos.toString();
            String[] masWords = strWords.split(",");
            Random random = new Random();
            for (int i = 0; i < masWords.length; i++) {
                int rand = random.nextInt(10000000);
                sql = "INsert into RandomWords(item_nm,item_cd) Values(?,?)";
                pstmt = con.prepareStatement(sql);
                pstmt.setString(1, masWords[i]);
                pstmt.setInt(2, rand);
                pstmt.executeUpdate();
            }           
            is.close();
            baos.close();
        } catch (IOException e) {
            e.printStackTrace();
        } catch (SQLException e) {
            System.out.println(e.getMessage());
        }finally {
            Connect.closeConnection();
        }
    }

    public static HashMap getDataFromDB(String pos, String mask) {
        HashMap returnMap = new HashMap();
        Connection con = Connect.getConnection();
        Properties propertie = new Properties();
        try {
            propertie.load(DataBase.class.getResourceAsStream("/database.properties"));
            String database = propertie.getProperty("mysqlDb");
            String sql = "USE " + database;
            Statement stmt = con.createStatement();
            stmt.execute(sql);
            sql = "SELECT DISTINCT item_id, item_nm FROM RandomWords Where ( item_nm like '"+ mask +"%')";
            sql += " Order By item_nm LIMIT "+ pos +",100";
            ResultSet rs = stmt.executeQuery(sql);
            while (rs.next()) {
                returnMap.put(rs.getString(1), rs.getString(2));
            }
        } catch (SQLException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }finally {
            Connect.closeConnection();
        }
        return returnMap;
    }
}
