package combo;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.apache.xml.serialize.OutputFormat;
import org.apache.xml.serialize.XMLSerializer;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import java.io.StringWriter;
import java.io.IOException;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;


public class XmlGenerator {

    public static void createXML(HttpServletRequest request, HttpServletResponse response) {
        String mask = request.getParameter("mask");
        String pos = request.getParameter("pos");
        HashMap wordsMap = DataBase.getDataFromDB(pos, mask);
        try {
            Document xmlDoc = DocumentBuilderFactory.newInstance().newDocumentBuilder().newDocument();
            Element root = xmlDoc.createElement("complete");
            if (!pos.equals("0")) {
                root.setAttribute("add", "true");
            }
            xmlDoc.appendChild(root);
            for (Iterator i = wordsMap.entrySet().iterator(); i.hasNext();) {
                Element elName = xmlDoc.createElement("option");
                Map.Entry e = (Map.Entry) i.next();
                elName.appendChild(xmlDoc.createTextNode((String) e.getValue()));
                elName.setAttribute("value", (String) e.getKey());
                root.appendChild(elName);
            }
            request.setAttribute("xml", serializeXml(xmlDoc));
        } catch (ParserConfigurationException e) {
            e.printStackTrace();
        }
    }

    static String serializeXml(Document xml) {
        StringWriter out = new StringWriter();
        OutputFormat format = new OutputFormat(xml);
        format.setIndenting(true);
        XMLSerializer serializer = new XMLSerializer(out, format);
        try {
            serializer.asDOMSerializer();
            serializer.serialize(xml);
        } catch (IOException e) {
            System.out.println(e.getMessage());
        }
        return out.toString();
    }
}
